/*
 * Copyright (c) 2005 DocJava, Inc. All Rights Reserved.
 */
package net.rmi.rjs.jobs;

import java.io.Serializable;
import java.util.Vector;
import java.util.Observer;
import java.util.Observable;

/**
 * This class does an async build of our answers.
 */
public class Answers   {
  private Vector v = new Vector();
  public void add(ComputeJob cj){

      ComputeThread ct = new ComputeThread(cj);
      ct.addObserver(new Observer(){
          public void update(Observable obs, Object obj){

              if (obj instanceof Serializable){
                  v.addElement(obj);
              }
          }
      });
  }

  public Serializable[] getAnswers(){
      Serializable sa[] = new Serializable[v.size()];
      v.copyInto(sa);
      return sa;
  }

    public void add(ComputeJobs cjs) {
        ComputeJob cja[] = cjs.getJobs();
        for (int i=0; i < cja.length; i++)
            add(cja[i]);

    }
}
