package net.rmi.ssl;

/**
 * Copyright DocJava, inc. User: lyon
 * <p/>
 * Date: Dec 6, 2004
 * <p/>
 * Time: 8:55:32 AM
 */
//RmiClientServerFactory
import gui.JInfoFrame;

import javax.net.ssl.*;
import java.io.*;
import java.rmi.server.RMIClientSocketFactory;
import java.net.Socket;
import java.security.KeyStore;

/**
 * Created by IntelliJ IDEA. User: pkrepszt Date: Nov 16, 2004 Time:
 * 7:24:57 PM 
 * Templates.
 */
public class RmiClientServerFactory implements RMIClientSocketFactory,
                                                  Serializable {
    private static JInfoFrame jif2 = new JInfoFrame();
    public static int port2 = 1024;
    public static void main(String args[]){
        RmiClientServerFactory rcsf = new RmiClientServerFactory();
        try {
            Socket s = rcsf.createSocket("wow",12);
        } catch (IOException e) {
            e.printStackTrace();

        }
    }

    public Socket createSocket(String IpAddress, int port)
            throws IOException {
        jif2.setSize(400, 400);
        jif2.show();
        // System.out.println("Client ip "+IpAddress);
        jif2.println("Client ip " + IpAddress);
        // System.out.println("Client port "+port);
        jif2.println("Client port " + port2);
        SSLSocketFactory ssf = null;
        try {
            char[] passphrase = "ewunia27".toCharArray();
            SSLContext ctx = SSLContext.getInstance("TLS");
            KeyStore ks = KeyStore.getInstance("JKS");
            ks.load(new FileInputStream("clientKeyStore"), passphrase);
            KeyStore ts = KeyStore.getInstance("JKS");
            ts.load(new FileInputStream("clientTrustStore"), null);
            KeyManagerFactory kmf = KeyManagerFactory.getInstance("SunX509");
            kmf.init(ks, passphrase);
            TrustManagerFactory tmf =
                    TrustManagerFactory.getInstance("SunX509");
            tmf.init(ts);
            ctx.init(kmf.getKeyManagers(), tmf.getTrustManagers(), null);
            //System.out.println("client KS "+ ks.getProvider().toString());b
            // System.out.println("client TMF "+
            tmf.getTrustManagers().toString();
            ssf = ctx.getSocketFactory();
            // System.out.println("client Ciphers "+
            ssf.getSupportedCipherSuites().toString();
        } catch (Exception e) {
            jif2.println(getStackTrace(e));
        }
        jif2.println("client2");

        return (SSLSocket) ssf.createSocket(IpAddress, port2);
    }

    public static String getStackTrace(Exception e) {
        ByteArrayOutputStream baos = new ByteArrayOutputStream();
        PrintStream ps = new PrintStream(baos);
        e.printStackTrace(ps);
        try {
            baos.close();
        } catch (IOException e1) {
            e1.printStackTrace();

        }
        return new String(baos.toByteArray());
    }
}